Subject: Re: [PATCH] net: hns: Ensure that interface teardown cannot race with TX interrupt

From: Marc Zyngier <[email-masked]>
Date: Wed, 6 Nov 2019 08:17:48 +0000

On Tue, 5 Nov 2019 18:41:11 +0000
Salil Mehta <[email-masked]> wrote:

Hi Salil,

> Hi Marc,
> I tested with the patch on D05 with the lockdep enabled kernel with below options
> and I could not reproduce the deadlock. I do not argue the issue being mentioned
> as this looks to be a clear bug which should hit while TX data-path is running
> and we try to disable the interface.

Lockdep screaming at you doesn't mean the deadly scenario happens in
practice, and I've never seen the machine hanging in these conditions.
But I've also never tried to trigger it in anger.

> Could you please help me know the exact set of steps you used to get into this
> problem. Also, are you able to re-create it easily/frequently?

I just need to issue "reboot" (which calls "ip link ... down") for this
to trigger. Here's a full splat[1], as well as my full config[2]. It is
100% repeatable.

> # Kernel Config options:
> CONFIG_LOCKDEP_SUPPORT=y
> CONFIG_LOCKDEP=y

You'll need at least 

CONFIG_PROVE_LOCKING=y
CONFIG_NET_POLL_CONTROLLER=y

in order to hit it.

Thanks,

	M.

[1] https://paste.debian.net/1114451/
[2] https://paste.debian.net/1114472/
-- 
Jazz is not dead. It just smells funny...